<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use App\Invitation;
use App\Setting;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */

    public function __construct()
    {

    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('invite');
    }

    public function sendInvite(Request $request)
    {

        $senderPhone = $this->formatNumber($request->sender_phone);

        $invites = 0;
        foreach ($request->receiver_phone as $receiverPh) {

            if ($receiverPh != '') {
                $receiverPhone = $this->formatNumber($receiverPh);

                $invite = Invitation::where("sender_phone", $senderPhone)->where("receiver_phone", $receiverPhone)->first();

                if ($invite) {

                    return response()->json(['res' => '2', 'coins_collected' => '', 'number' => $receiverPh]);

                }
                $invites++;
            }

        }

        $coins = $invites * 5;

        $sessionSenderPhone = session('sender_phone');
        $code = $this->randomStrings(9);
        if ($sessionSenderPhone == $request->sender_phone) {

            $code = session('code');
            $coins = $coins + session('coins_collected');
        }

        session(['code' => $code, 'sender_phone' => $request->sender_phone, 'sender_name' => $request->sender_name, 'coins_collected' => $coins]);

        //Send Message To Sender
        $messageToSender = "Input the code below to claim your coins: $coins\n\nCode: $code\n\nShare the app with a friend to earn more 💰💰! ";
        $media = '';
        $this->sendSms($senderPhone, $messageToSender, $media);

        foreach ($request->receiver_phone as $receiverPh) {

            if ($receiverPh != '') {
                $receiverPhone = $this->formatNumber($receiverPh);
                $obj = new Invitation();

                $obj->sender_phone = $senderPhone;
                $obj->sender_name = $request->sender_name;
                $obj->receiver_phone = $receiverPhone;
                $obj->coins_collected = '5';
                $obj->code = $code;
                $obj->save();

                //Send Message To Receiver
                $senderName = $request->sender_name != '' ? $request->sender_name : 'We';
                $messageToReceiver = "$senderName invited you to join Octi App!\n\nLink: https://apps.apple.com/us/app/octi/id1573463341\n\nUse Octi to create videos, earn coins, and collect your favorite digital objects!";
                $this->sendSms($receiverPhone, $messageToReceiver, $media);
            }

        }

        return response()->json(['res' => '1', 'coins_collected' => $coins, 'number' => '']);

        // return "";

    }

    public function formatNumber($number)
    {
        $formatedNumber = str_replace(' ', '', $number);
        $formatedNumber = str_replace('(', '', $formatedNumber);
        $formatedNumber = str_replace(')', '', $formatedNumber);
        $formatedNumber = str_replace('-', '', $formatedNumber);
        $formatedNumber = '+1' . $formatedNumber;
        return $formatedNumber;
    }

    public function randomStrings($lengthOfString)
    {

        // String of all alphanumeric character
        $strResult = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

        // Shuffle the $str_result and returns substring
        // of specified length
        return substr(str_shuffle($strResult), 0, $lengthOfString);
    }

    public function sendSms($toNumber, $body, $media)
    {

        $settings = Setting::where('user_id', '1')->first();

        $twilioSid = $settings->twilio_sid;
        $twilioToken = $settings->twilio_token;
        $fromNumber = $settings->twilio_number;

        $url = "https://$twilioSid:$twilioToken@api.twilio.com/2010-04-01/Accounts/$twilioSid/Messages";
        if ($media != '') {
            $val = array(
                "To" => $toNumber,
                "From" => $fromNumber,
                "Body" => $body,
                "MediaUrl" => $media,
            );
        } else {
            $val = array(
                "To" => $toNumber,
                "From" => $fromNumber,
                "Body" => $body,
            );
        }

        $curl = curl_init(); // Initialize the curl
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_URL, $url); // set the opton for curl
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); // set the option to transfer output from script to curl
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $val);
        $response = curl_exec($curl);
        curl_close($curl);

        return $response;

    }
}
